package org.jeecg.modules.stm.metric.controller;

import java.util.Arrays;
import java.util.List;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.metric.service.IMetricAppSystemReportService;
import org.jeecg.modules.stm.metric.service.IMetricAppSystemService;
import org.jeecg.modules.stm.metric.entity.MetricAppSystem;
import org.jeecg.modules.stm.metric.entity.MetricAppSystemReport;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 重要信息系统表
 * @Author: jeecg-boot
 * @Date:   2024-03-23
 * @Version: V1.0
 */

@RestController
@RequestMapping("/metric/metricAppSystem")
@Slf4j
public class MetricAppSystemController extends JeecgController<MetricAppSystem, IMetricAppSystemService> {
	@Autowired
	private IMetricAppSystemService metricAppSystemService;
	@Autowired
	private IMetricAppSystemReportService metricAppSystemReportService;
	
	/**
	 * 分页列表查询
	 *
	 * @param metricAppSystem
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "重要信息系统表-分页列表查询")

	@GetMapping(value = "/list")
	public Result<IPage<MetricAppSystem>> queryPageList(MetricAppSystem metricAppSystem,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<MetricAppSystem> queryWrapper = QueryGenerator.initQueryWrapper(metricAppSystem, req.getParameterMap());
		Page<MetricAppSystem> page = new Page<MetricAppSystem>(pageNo, pageSize);
		IPage<MetricAppSystem> pageList = metricAppSystemService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param metricAppSystem
	 * @return
	 */
	@AutoLog(value = "重要信息系统表-添加")

	@RequiresPermissions("metric:metric_app_system:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody MetricAppSystem metricAppSystem) {
		metricAppSystemService.save(metricAppSystem);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param metricAppSystem
	 * @return
	 */
	@AutoLog(value = "重要信息系统表-编辑")

	@RequiresPermissions("metric:metric_app_system:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody MetricAppSystem metricAppSystem) {
		metricAppSystemService.updateById(metricAppSystem);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "重要信息系统表-通过id删除")

	@RequiresPermissions("metric:metric_app_system:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		metricAppSystemService.removeById(id);

		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "重要信息系统表-批量删除")

	@RequiresPermissions("metric:metric_app_system:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		List<String> idList = Arrays.asList(ids.split(","));
		this.metricAppSystemService.removeByIds(idList);
		QueryWrapper<MetricAppSystemReport> queryWrapper = new QueryWrapper<>();
		queryWrapper.in("app_sys_id",idList);
		this.metricAppSystemReportService.remove(queryWrapper);

		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "重要信息系统表-通过id查询")

	@GetMapping(value = "/queryById")
	public Result<MetricAppSystem> queryById(@RequestParam(name="id",required=true) String id) {
		MetricAppSystem metricAppSystem = metricAppSystemService.getById(id);
		if(metricAppSystem==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(metricAppSystem);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param metricAppSystem
    */
    @RequiresPermissions("metric:metric_app_system:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, MetricAppSystem metricAppSystem) {
        return super.exportXls(request, metricAppSystem, MetricAppSystem.class, "重要信息系统表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("metric:metric_app_system:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, MetricAppSystem.class);
    }

}
